@echo off

setlocal

if "%3" == "" (
	echo Usage: XsdPeekFeature "DFS schema file" "property name" "property value"... 1>&2
	goto end
)

set cpath="%~dp0."
set schema="%~f1"
set target="%temp%\pftarget.$$$"
set feature="%temp%\pffeat.$$$"

java -classpath %cpath% FindSchemaString --dfs-target-namespace %schema% | java -classpath %cpath% PrependLine "--namespace =" > %target%
java -classpath %cpath% FindSchemaString --dfs-feature %schema% > %feature%

java -classpath %cpath% FileEmptyChecker %target%
if %ERRORLEVEL% == 0 goto error
java -classpath %cpath% FileEmptyChecker %feature%
if %ERRORLEVEL% == 0 goto error

shift
shift
java -classpath %cpath% PeekFeature -@ %target% -@ %feature% %0 %1 %2 %3 %4 %5 %6 %7 %8 %9

goto success

:error
echo Error: Malformed DFS schema file 1>&2

:success

if exist %target%  del %target%
if exist %feature% del %feature%

:end

endlocal
