/* */

import java.io.*;
import java.util.regex.*;
import java.util.ArrayList;
import java.util.Arrays;

/**
 * XSDDFSΥޥե뤫ΰȴФ
 * ȴФ target namespace, feature name Τɤ餫
 * ɤȴФϥץǻꤹ롣
 *
 * @author YOKOTA Hiroshi
 */
public class FindSchemaString {
	//** ȴФ٤ʸΥѥ
	/* xsd */
	private static final Pattern target       = Pattern.compile("targetNamespace=([\"'])([^\"']+)\\1");
	private static final int     target_group = 2;
	private static final Pattern feature       = Pattern.compile("<xsd?:element\\s+name=([\"'])(\\w+)\\1\\s+type=([\"'])[\\w:]+\\3\\s+substitutionGroup=([\"'])gml:_Feature\\4/>");
	private static final int     feature_group = 2;

	/* dfs */
	private static final Pattern dfs_target	       = Pattern.compile("\"TargetNamespace\",\"([^\"]+)\"");
	private static final int     dfs_target_group  = 1;
	private static final Pattern dfs_feature       = Pattern.compile("\"FeatureType\",\"(\\w+)\",\"\\1Type\"");
	private static final int     dfs_feature_group = 1;


	/* ================================================================= */

	/**
	 * ʸȴФ
	 */
	private static void find_string(Pattern p, int group, BufferedReader fd) throws IOException {
		String line;

		while((line = fd.readLine()) != null) {
			Matcher match = p.matcher(line);

			if(match.find()) {
				System.out.println(match.group(group));
			}
		}
	}

	/**
	 * ǻꤷʸե̾Ȥߤʤƽ
	 */
	private static void args_process(Pattern pattern, int group, ArrayList<String> args) {
		for(String i: args) {
			BufferedReader fd;

			try {
				fd = new BufferedReader(new FileReader(i));
			} catch(FileNotFoundException e) {
				throw new RuntimeException("file not found: " + i);
			}

			try {
				find_string(pattern, group, fd);

				fd.close();
			} catch(IOException e) {
				throw new RuntimeException("file read error: " + i);
			}
		}
	}

	/**
	 * ɸϤɤ߹ǽ
	 */
	private static void stdin_process(Pattern pattern, int group) {
		try {
			find_string(pattern, group, new BufferedReader(new InputStreamReader(System.in)));
		} catch(IOException e) {
			throw new RuntimeException("stdin read error");
		}
	}

	/**
	 * ޥե뤫ȴФɽ
	 */
	public static void main(String args[]) {
		ArrayFileExtractor afe = new ArrayFileExtractor("-@", args);

		ArrayList<String> p_args = afe.toExtractedList();
		Pattern pat;
		int grp;

		if(args.length < 1) {
			System.err.println("Error: args too short");

			usage();
			System.exit(1);
			throw new RuntimeException();
		}


		if(p_args.get(0).equals("--target-namespace")) {
			pat = target;
			grp = target_group;
		} else if(p_args.get(0).equals("--feature")) {
			pat = feature;
			grp = feature_group;
		} else if(p_args.get(0).equals("--dfs-target-namespace")) {
			pat = dfs_target;
			grp = dfs_target_group;
		} else if(p_args.get(0).equals("--dfs-feature")) {
			pat = dfs_feature;
			grp = dfs_feature_group;
		} else {
			System.err.println("Error: malformed option");

			usage();
			System.exit(2);
			throw new RuntimeException();
		}

		p_args.remove(0);

		if(p_args.size() == 0) {
			stdin_process(pat, grp);
		} else {
			args_process(pat, grp, p_args);
		}

	}

	private static void usage() {
		System.err.printf("Usage: java FindSchemaString [--target-namespace|--feature|--dfs-target-namespace|--dfs-feature] [files...]%n%n" +
				  " If no files specified, use STDIN.%n");
	}

}

/* end */
